package MobileMonitoring;

/**classe contenente tutte le informazioni necessarie ad un agente mobile, nel ruolo di manager Snmp,
//per effettuare il polling di una o piu' variabili Snmp, di una tabella, delle righe di una tabella
//che rispettano una certa condizione
*/
//io penso sara' per un solo nodo...
public class InfoPolling implements StaticMonitoring.Operations
{
    int observation_time;
    int poll_interval;
    int op_type;
    Object infos;

    //interval e' la durata del polling (millisec)
    //delay e' la cadenza con cui si esegue il polling (millisec)
    //op e' il tipo di operazione da ripetere (come definite nell'interfaccia Operations)
    //i e' l'oggetto contenete tutte le informazioni associate all'operazione: op mi
    //permette di capire di quale particolare Info.. si tratta
    public InfoPolling(int interval, int delay, int op, Object i)
    {
        infos = i;
        observation_time = interval;
        poll_interval = delay;
        op_type = op;
    }

    public int HowLong()
    {
        return observation_time;
    }

    public int HowOften()
    {
        return poll_interval;
    }

    public int OpToRepeat()
    {
        return op_type;
    }

    public Object getInfo()
    {
        return infos;
    }

}
