import SOMA.agent.*;
import SOMA.naming.*;
import java.io.PrintStream;
import SOMA.mobilePlace.*;
import java.util.*;

public class Tour1 extends Agent
{
  PlaceID[] places = null;
  int index = -1;  // Al primo tour  messo a zero!
  static final String Header = "******";
  Vector placesD = new Vector();
  PlaceID placeAttu;


/**
  public void putArgument( Object obj )
  {
    String[] PlaceNames = (String[])obj;
    places = new PlaceID[PlaceNames.length];

    for( int i = 0; i < PlaceNames.length; i++ )
    {
      try
      {
        //places[i] = new PlaceID( PlaceNames[i] );
        places[i] = SOMA.mobilePlace.MobilePlaceID.parsePlaceID( PlaceNames[i] );
      }
      catch( NameException e )
      {
        try
        {
          places[i] = new PlaceID( "DummyDomain DummyPlace"  );
        }
        catch( NameException f )
        {
          f.printStackTrace();
        }
      }
    }
  }*/

  public void run()
  {
    PrintStream out = agentSystem.getOut();
    placeAttu = agentSystem.getPlaceID();
	places = agentSystem.getDomains();
	for(int i=0;i< places.length; i++ )
	{
		if(!places[i].equals(placeAttu))
		{
			placesD.addElement(places[i]);
		}
	}


    out.println( Header + getID().toString() + " This is my tour:" );

    int i;

    for( i = 0; i < placesD.size(); i++ )
      out.println( Header + getID().toString() + "  " + i + ") " + placesD.get(i) );

    out.println( Header + getID().toString() );
    out.println( Header + getID().toString() );
    out.println( Header + getID().toString() + "     STARTING TOUR!!!" );
    out.println( Header + getID().toString() );
    out.println( Header + getID().toString() );

    tour();
  }

  public void tour()
  {
    PrintStream out = agentSystem.getOut();

    index++;

    if( index < placesD.size() )
    {
      //if( index == 0 )
        //out.println( Header + getID().toString() + "  " + index + ")  --> " + (String)placesD.get(index) );
     // else
        //out.println( Header + getID().toString() + "  " + index + ") " + (String)placesD.get(index - 1) + " --> " + (String)placesD.get(index) );

      try
      {
        eseguiAzioneGoto( (PlaceID)placesD.get(index));
      }
      catch( CantGoException e )
      {
        e.printStackTrace( out );
        out.println( Header + getID().toString() );
        out.println( Header + getID().toString() + "  GOING TO NEXT PLACE" );
        out.println( Header + getID().toString() );
        tour();
      }
    }
    else
    {
      out.println( Header + getID().toString() + "  END OF THE TOUR!!!" );
    }
  }



    public void eseguiAzioneGoto (PlaceID placeToGoTo) throws CantGoException {
      // NB: l'eccezione viene "presa" dalla finestra FinGoto1000, che provveder a stamparla in una finestra
  	PrintStream out = agentSystem.getOut();


      PlaceID placeAtt = agentSystem.getPlaceID();

      if (! placeToGoTo.equals(placeAtt)) {
        out.println(placeToGoTo);

        //era: go (new PlaceID(Answer), "startMethod");
        try {

          PlaceID mobilePlaceID = MobilePlaceID.parsePlaceID (placeToGoTo.toString());

             // Mi ricorder il place su cui volevo migrare.


          go (mobilePlaceID, "tour");


        }
        catch (Exception e) {
          e.printStackTrace(out);
        }
      }
      else
        out.println("i place sono uguali");

  } //eseguiAzioneGoto
}