package MobileMonitoring;

import SOMA.naming.*;
import java.io.Serializable;

/**classe contenente le informazioni necessarie ad un agente mobile, nel ruolo di
//StaticManager, per effettuare richieste Snmp atomiche (get/getnext/getbulk) basandosi
//eventualmente (v3) sulla configurazione del motore.
*/
public class InfoHF implements Serializable
{
	InfoAtomicSnmpOp sub = null;
	//stringa corrispondente alla health function
	String HF;
	//identificatore di riga inizializzato solo nel caso in cui si voglia calcolare la HF su una tabella
	String rowID = null;
	
    /**costruttore
    */
    public InfoHF(InfoAtomicSnmpOp info, String hf)
    {
		sub = info;
        HF = hf;
    }
	
    /**costruttore
    */
    public InfoHF(InfoAtomicSnmpOp info, String hf, String row)
    {
		sub = info;
        HF = hf;
        rowID = row;
    }
    
    //restituisce la lista degli object identifier da richiedere ad ogni agente Snmp visitato
    public String getHF()
    {
        return HF;
    }
    
    public String getrowID()
    {	
    	return rowID;
    }

}