package MonitorConfig;

import java.io.*;

public class Debug
{
    PrintStream out;
    boolean debug;

    public Debug()
    {
        out = System.out;
        debug = false;
    }

    public Debug(boolean deb,PrintStream o)
    {
        out = o;
        debug = deb;
    }

    public void trace_err(String s)
    {
        String current_class = (getClass().getName())+">";
        if (debug)
            out.println(current_class+s);
    }

	public void trace(String s)
	{
		out.println(s);
	}

    public boolean isDebug()
    {
        return debug;
    }

    public void setDebug(boolean status)
    {
        debug = status;
    }

    public PrintStream getOut()
    {
        return out;
    }

    public void setOut(PrintStream o)
    {
        out = o;
    }

}

