/**
*
*
*
*	@author     Ialacci Massimiliano
*	@version    1.00
*	@language   jdk 1.2.2
*
*/

/* Questo agente si occupa di guidare l'utente nella procedura di
	registrazione e di effettuare la stessa */
import java.io.*;
import java.lang.*;
import java.util.*;

import SOMA.massimiliano.*;
import SOMA.agent.*;
import SOMA.naming.*;


public class RegistratoreProfilo1 extends Agent
{
	int contatore = -1;//per ricerca nome

	String line = "";/*la uso come contenitore per le righe
									dei vettori di testo */
	String percorso = "c:"+File.separator+"Soma"+File.separator+
						"SOMA"+File.separator+"massimiliano"+
						File.separator;
	String fileIstr = percorso+"istruzioniRegistrazione.txt";
	String fileLayout = percorso+"LayoutProfilo.txt";
	String nomeR;//nome di riferimento per il file di profilo
	String dir = File.separator+"esempiRegistrazione";
	String lay = dir+File.separator+"registrazione.txt";
	String nameP ;//nome del DP attuale
	String destinazione;
	String nameDP;//per ricerca nome
	String ricerca;//per ricerca nome

	boolean controllo;/* lo utilizzo per controllare
									se l'utente sa come registrarsi */

	BufferedReader in;

	Vector istruzioni = new Vector();/*vettore che uso per contenere
										il file di istruzioni */
	Vector layout = new Vector();	 /*vettore che uso per contenere
										il file LayoutProfili */
	Vector profilo = new Vector();	 /*vettore che uso per contenere
										il file con il profilo*/
	Vector placesD = new Vector();	/*vettore dei places da visitare*/

	PlaceID placeAtt ;//place di partenza
	PlaceID[] places = null ;//per ricerca nome
	PlaceID dpAtt;//per ricerca nome


	public void putArgument( Object obj)
	{
		String[] parametroP = ( String[] ) obj;
		if(parametroP.length == 1)
		{
			nomeR = parametroP[0];
			controllo = false;
		}
		else
		{
			controllo = true;
		}
	}


	public void run()
	{
		PrintStream out = agentSystem.getOut();

		if( controllo )
		{
			/* estraggo un vettore da un file testo e lo visualizzo
				(contiene le istruzioni per registrarsi) */

			FileVector vet = new FileVector(fileIstr);
			istruzioni = vet.vettorizza(out);
			out.println("");
			for(int i =0; i < istruzioni.size(); i++)
			out.println(istruzioni.get(i));
			out.println("");

			/* creazione di directory e file da riempire per la registrazione */

			CreateDir directory = new CreateDir(dir);
			directory.createDir(out);
			FileVector vet1 = new FileVector(fileLayout);
			layout = vet1.vettorizza(out);
			CreateFileText fileT = new CreateFileText(lay,layout);
			fileT.createFile(out);
			fileT.save(out);


		}
		else
		{

			FileVector vet2 = new FileVector(lay);
			profilo = vet2.vettorizza(out);

			placeAtt = agentSystem.getPlaceID();
			nameP = placeAtt.toString();

			destinazione = System.getProperty("user.dir")+File.separator+nameP+File.separator+"ProfiliUtente";
			CreateDir directory = new CreateDir(destinazione);
			directory.createDir(out);

			File test = new File(destinazione+File.separator+nomeR+".txt");
			if(test.exists())
			{
				messaggio();
			}
			else
			{
				//out.println("qui");
				places = agentSystem.getDomains();//contiene tutti i DP
				//out.println("qui1");
				for(int i=0;i< places.length; i++ )
				{
					//out.println("qui2");
					if(!places[i].equals(placeAtt))
					{
						placesD.addElement(places[i]);
					}
				}
				//out.println("qui3");
				for(int i = 0; i < placesD.size() ; i++)
				{
					//out.println("qui4");
					out.println( i+") "+placesD.get(i));
				}
				ricercaNome();

			}
			//out.println("il nome di riferimento : "+nomeR);
			//out.println("il nome del DP : "+nameP);
		}
	}

	public void ricercaNome()
	{
		PrintStream out = agentSystem.getOut();
		boolean trovato = false;
		if(contatore != -1)
		{
			dpAtt = agentSystem.getPlaceID();

			nameDP = dpAtt.toString();
			out.println("il dp  "+nameDP);
			ricerca = System.getProperty("user.dir")+File.separator+nameDP+File.separator+"ProfiliUtente";
			File test1 = new File(ricerca+File.separator+nomeR+".txt");
			if(test1.exists())
			{
				out.println("trovato");
				out.println("il place di partenza  :"+placeAtt.toString());
				trovato = true;
				try
				{
					go(placeAtt,"messaggio");
				}
				catch( CantGoException e)
				{
					e.printStackTrace(out);
				}
			}
			else
			{
				trovato = false;
			}
		}

		contatore++;
		if(!trovato)
		{
			if(contatore < placesD.size())
			{
				out.println("vado a :"+placesD.get(contatore));
				try
				{
					go((PlaceID)placesD.get(contatore),"ricercaNome");
				}
				catch( CantGoException e)
				{
					e.printStackTrace( out );
				}
			}
			else
			{
				try
				{
					go(placeAtt,"saveProfiling");
				}
				catch( CantGoException e)
				{
					e.printStackTrace(out);
				}
			}
		}
	}

	public void messaggio()
	{
		PrintStream out = agentSystem.getOut();
		out.println("il nome di riferimento che hai usato  gia esistente!!!");
		out.println("Devi modificarlo sia nel file registrazione.txt");
		out.println("che nella successiva chiamata all' agente");
		out.println("LA REGISTRAZIONE NON  ANDATA A BUON FINE!!!!!");
	}

	public void saveProfiling()
	{
		PrintStream out = agentSystem.getOut();

		//crea il file profilo nel DP
		CreateFileText fileT = new CreateFileText(destinazione+File.separator+nomeR+".txt",profilo);
		fileT.createFile(out);
		fileT.save(out);

		/** Cancellazione della directory :"esempi di registrazione" e
			del file registrazione.txt */
		File del = new File(lay);
		del.delete();
		File del1 = new File(dir);
		del1.delete();
		out.println("La registrazione  andata a buon fine");
	}

}
